package org.jeecg.modules.demo.linkwhiteword.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.demo.linkwhiteword.entity.LinkWhiteWord;
import org.jeecg.modules.demo.linkwhiteword.service.ILinkWhiteWordService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.demo.mainsite.entity.MainSite;
import org.jeecg.modules.demo.mainsite.service.IMainSiteService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 白名单词汇
 * @Author: jeecg-boot
 * @Date:   2023-04-12
 * @Version: V1.0
 */
@Api(tags="白名单词汇")
@RestController
@RequestMapping("/linkwhiteword/linkWhiteWord")
@Slf4j
public class LinkWhiteWordController extends JeecgController<LinkWhiteWord, ILinkWhiteWordService> {

	@Autowired
	private ILinkWhiteWordService linkWhiteWordService;

	@Autowired
	private IMainSiteService iMainSiteService;

	/**
	 * 分页列表查询
	 *
	 * @param linkWhiteWord
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "白名单词汇-分页列表查询")
	@ApiOperation(value="白名单词汇-分页列表查询", notes="白名单词汇-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<LinkWhiteWord>> queryPageList(LinkWhiteWord linkWhiteWord,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<LinkWhiteWord> queryWrapper = QueryGenerator.initQueryWrapper(linkWhiteWord, req.getParameterMap());
		Page<LinkWhiteWord> page = new Page<LinkWhiteWord>(pageNo, pageSize);
		IPage<LinkWhiteWord> pageList = linkWhiteWordService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	/**
	 *   添加
	 *
	 * @param linkWhiteWord
	 * @return
	 */
	@AutoLog(value = "白名单词汇-添加")
	@ApiOperation(value="白名单词汇-添加", notes="白名单词汇-添加")
	@RequiresPermissions("linkwhiteword:link_white_word:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody LinkWhiteWord linkWhiteWord) {
		try {
			String mainSiteId = linkWhiteWord.getMainSiteId();
			MainSite mainSite = iMainSiteService.getById(mainSiteId);
			linkWhiteWord.setMainSiteName(mainSite.getMainSiteName());
			linkWhiteWord.setMainSiteUrl(mainSite.getMainSiteUrl());
		}catch (Exception e){
			e.printStackTrace();
		}
		linkWhiteWordService.save(linkWhiteWord);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param linkWhiteWord
	 * @return
	 */
	@AutoLog(value = "白名单词汇-编辑")
	@ApiOperation(value="白名单词汇-编辑", notes="白名单词汇-编辑")
	@RequiresPermissions("linkwhiteword:link_white_word:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody LinkWhiteWord linkWhiteWord) {
		try {
			String mainSiteId = linkWhiteWord.getMainSiteId();
			MainSite mainSite = iMainSiteService.getById(mainSiteId);
			linkWhiteWord.setMainSiteName(mainSite.getMainSiteName());
			linkWhiteWord.setMainSiteUrl(mainSite.getMainSiteUrl());
		}catch (Exception e){
			e.printStackTrace();
		}
		linkWhiteWordService.updateById(linkWhiteWord);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "白名单词汇-通过id删除")
	@ApiOperation(value="白名单词汇-通过id删除", notes="白名单词汇-通过id删除")
	@RequiresPermissions("linkwhiteword:link_white_word:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		linkWhiteWordService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "白名单词汇-批量删除")
	@ApiOperation(value="白名单词汇-批量删除", notes="白名单词汇-批量删除")
	@RequiresPermissions("linkwhiteword:link_white_word:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.linkWhiteWordService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "白名单词汇-通过id查询")
	@ApiOperation(value="白名单词汇-通过id查询", notes="白名单词汇-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<LinkWhiteWord> queryById(@RequestParam(name="id",required=true) String id) {
		LinkWhiteWord linkWhiteWord = linkWhiteWordService.getById(id);
		if(linkWhiteWord==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(linkWhiteWord);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param linkWhiteWord
    */
    @RequiresPermissions("linkwhiteword:link_white_word:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, LinkWhiteWord linkWhiteWord) {
        return super.exportXls(request, linkWhiteWord, LinkWhiteWord.class, "白名单词汇");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("linkwhiteword:link_white_word:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, LinkWhiteWord.class);
    }

}
